<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";
@Component({})
export default class AdminSettingsPaymentComponent extends Vue {
	config = {
		page: 1,
		limit: 25,
		search: "",
	};
	page = 1;

	configSeller = {
		page: 1,
		limit: 25,
		search: "",
	};
	totalPageSeller = 0;

	listSeller = [];
	listSellerIds = [];

	loadingTableSeller = false;

	stats = {
		amount: 0,
		order: 0,
		seller: 0,
	};

	paymentId = "";
	userPaymentId = "";

	paymentDetail: any = {};

	dialogAddSeller = false;
	dialogRemoveSeller = false;

	loading = false;
	loadingStats = false
	loadingListSeller = false

	get totalPage() {
		return this.$store.state.adminPayment.totalPage || 0;
	}

	get total() {
		return this.$store.state.adminPayment.total || 0;
	}

	get loadingTable() {
		return this.$store?.state?.adminPayment?.loadingTable || false;
	}

	get listAdminSeller() {
		return this.$store.state.adminPayment.listAdminSeller || [];
	}

	mounted() {
		this.paymentId = this.$route.params.id || "";
		if (this.paymentId) {
			this.onGetListAdminSeller();
			this.onGetDetail();
			this.onGetStats();
		}
	}

	async onGetDetail() {
		try {
			const response = await this.$api.payment.detail(this.paymentId);
			if (response?.data) {
				this.paymentDetail = response.data;
			}
		} catch (error) {
			apiErrorHandler(error, this);
		}
	}

	async onGetStats() {
		try {
			this.loadingStats = true
			const response = await this.$api.payment.statsAdmin(this.paymentId);
			if (response?.data) {
				const { amount, order, seller } = response.data;
				this.stats = {
					amount,
					order,
					seller,
				};
			}
		} catch (error) {
			apiErrorHandler(error, this);
		} finally {
			this.loadingStats = false
		}
	}

	async onChangeStatus(payment: any) {
		try {
			await this.$api.payment.update(payment._id, {
				enabled: payment.enabled,
			});
			this.$pushNotification.success("Successful status change");
			this.onGetDetail();
		} catch (error) {
			apiErrorHandler(error, this);
		}
	}

	async onGetListAdminSeller() {
		await this.$store.dispatch("adminPayment/onGetListAdminSeller", {
			ctx: this,
			query: this.config,
			paymentId: this.paymentId,
		});
	}

	async onGetListSeller() {
		try {
			this.loadingListSeller = true
			const response = await this.$api.userAdmin.listSeller(
				this.configSeller
			);
			if (response?.data?.data) {
				const { total } = response.data;
				this.totalPageSeller = Math.ceil(
					total / this.configSeller.limit
				);
				this.listSeller = response.data.data;
			}
		} catch (error) {
			apiErrorHandler(error, this);
		} finally {
			this.loadingListSeller = false
		}
	}

	openDialogAddSeller() {
		this.onGetListSeller();
		this.configSeller = {
			page: 1,
			limit: 25,
			search: "",
		};
		this.dialogAddSeller = true;
	}

	closeDialogAddSeller() {
		this.dialogAddSeller = false;
	}

	openDialogDeleteSeller(userPaymentId: string) {
		if (userPaymentId) {
			this.dialogRemoveSeller = true;
			this.userPaymentId = userPaymentId;
		}
	}

	closeDialogDeleteSeller() {
		this.dialogRemoveSeller = false;
	}

	async onAddSeller() {
		try {
			this.loading = true;
			const payload = {
				paymentId: this.paymentId,
				listSellerId: this.listSellerIds,
			};
			await this.$api.payment.attach(payload);
			this.$pushNotification.success("Successfully added partners");
			this.dialogAddSeller = false;
			this.listSellerIds = [];
			this.onGetListAdminSeller();
		} catch (error) {
			apiErrorHandler(error, this);
		} finally {
			this.loading = false;
		}
	}

	async onDeleteSeller() {
		try {
			this.loading = true;
			await this.$api.payment.deleteUserPayment(this.userPaymentId);
			this.$pushNotification.success("Delete partner successfully");
			this.dialogRemoveSeller = false;
			this.onGetListAdminSeller();
		} catch (error) {
		} finally {
			this.loading = false;
		}
	}

	onRedirectPage() {
		this.config.page = this.page;
		this.onGetListAdminSeller();
	}

	@Watch("config.page")
	changedPage() {
		this.onGetListAdminSeller();
	}
}
</script>

<style></style>
